---------------------------------------------------------------------------
-- Mod P division. Fermats little teorem Algorithm
---------------------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Galois; use Galois;
procedure Algorithm5 is
   X, Y, Z, E, Ty, Tx, Q, W, xmodp: Natural;
   P_Minus2: Bit_Vector;
begin
   X := 149;
   for I in 1 .. P-1 loop
      Y := I;
      Q := P-2;
      for I in 0 .. logp-1 loop P_Minus2(I) := Q mod 2; Q := Q/2; end loop;
      ---------------------------------------------------
      E := Exp_K;
      Ty := Mp(Y, Exp_2k);
      Tx := Mp(X, Exp_2k);      
      for I in 1 .. Logp loop
         E := Mp(E, E);
         if P_Minus2(Logp-I) = 1 then E := Mp(E, Ty); end if;
      end loop;
      E := Mp(E, Tx);
      Z := Mp(E, 1);
      --------------------------------------------------
      Put(X);Put("/"); Put(Y); Put(" mod "); Put(P); Put(" = "); Put(Z);  New_Line;
      W := (Z*Y) mod p; xmodp := X mod p; 
      Put("z*y mod p= "); Put(W);  New_Line;
      if W /= xmodp then Put("ERROR"); end if; New_Line; New_Line;
   end loop;
end Algorithm5;
