---------------------------------------------------------------------------
-- Mod P division. Plus-minus Algorithm
---------------------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Galois; use Galois;
procedure Algorithm3 is
   A, Y, B, Min, Dif, Old_A, Z, X, C, D, Old_C, W, xmodp: Integer;
begin
   X := 149;
   for I in 1 .. P-1 loop
      Y := I;
      ---------------------------------------------------   
      A := Y; B := P; C := X; D := 0; Dif := 0; Min := Logp;  
      while Min > 0 loop
         if A mod 4 = 0 then 
            A := A/4; C := Divide_By_4(C, P);
            if Dif <= 0 then Min := Min-2; 
            elsif Dif = 1 then Min := Min-1; end if; 
            Dif := Dif-2;
         elsif A mod 2 = 0 then 
            A := A/2; C := Divide_By_2(C, P);
            if Dif <= 0 then Min := Min-1; end if;
            Dif := Dif-1;
         else
            Old_A := A; Old_C := C;
            if (A+B) mod 4 = 0 then 
               A := (A+B)/4; C := Divide_By_4(C+D, P);
               if Dif  >= 0 then
                  if Dif = 0 then Min := Min-1; end if;
                  Dif := Dif-1;
               else 
                  B:= Old_A; D := Old_C; 
                  Dif := -Dif-1;
               end if;
            else 
               A := (A-B)/4; C := Divide_By_4(C-D, P);
               if Dif  >= 0 then
                  if Dif = 0 then Min := Min-1; end if;
                  Dif := Dif-1;
               else 
                  B:= Old_A; D := Old_C; 
                  Dif := -Dif-1;
               end if;
            end if;
         end if;
        -- uncomment to see algorithm evolution
        -- Put("A: "); Put(A); Put(" B: "); Put(B); Put(" C: "); Put(C);
        -- Put(" D: "); Put(D); Put(" dif: "); Put(dif); Put(" min: "); Put(min);  New_Line;
      end loop;
      if B < 0 and D < 0 then Z := -D;
      elsif B < 0 and D >= 0 then Z := P - D;
      elsif B > 0 and D < 0 then Z := P + D;
      else Z := D;
     end if;
      --------------------------------------------------
      Put(X);Put("/"); Put(Y); Put(" mod "); Put(P); Put(" = "); Put(Z);  New_Line;
      W := (Z*Y) mod p; xmodp := X mod p; 
      Put("z*y mod p= "); Put(W);  New_Line;
      if W /= xmodp then Put("ERROR"); end if; New_Line; New_Line;
   end loop;
end Algorithm3;
